Index: sys/netinet6/raw_ip6.c
===================================================================
--- sys/netinet6/raw_ip6.c	(revision 312784)
+++ sys/netinet6/raw_ip6.c	(working copy)
@@ -560,9 +560,10 @@ rip6_output(struct mbuf *m, struct socket *so, ...
  * Raw IPv6 socket option processing.
  */
 int
-rip6_ctloutput(struct socket *so, struct sockopt *sopt)
+rip6_ctloutput(void *xpcb, struct sockopt *sopt)
 {
-	struct inpcb *inp;
+	struct inpcb *inp = (struct inpcb *)xpcb;
+	struct socket *so = inp->inp_socket;
 	int error;
 
 	if (sopt->sopt_level == IPPROTO_ICMPV6)
@@ -574,7 +575,6 @@ int
 	else if (sopt->sopt_level != IPPROTO_IPV6) {
 		if (sopt->sopt_level == SOL_SOCKET &&
 		    sopt->sopt_name == SO_SETFIB) {
-			inp = sotoinpcb(so);
 			INP_WLOCK(inp);
 			inp->inp_inc.inc_fibnum = so->so_fibnum;
 			INP_WUNLOCK(inp);
@@ -623,7 +623,7 @@ int
 			error = ip6_raw_ctloutput(so, sopt);
 			break;
 		default:
-			error = ip6_ctloutput(so, sopt);
+			error = ip6_ctloutput(inp, sopt);
 			break;
 		}
 		break;
Index: sys/sys/file.h
===================================================================
--- sys/sys/file.h	(revision 312784)
+++ sys/sys/file.h	(working copy)
@@ -54,7 +54,7 @@ struct vnode;
 #endif /* _KERNEL */
 
 #define	DTYPE_VNODE	1	/* file */
-#define	DTYPE_SOCKET	2	/* communications endpoint */
+#define	DTYPE_SOCKET	2	/* regular (data flow) socket */
 #define	DTYPE_PIPE	3	/* pipe */
 #define	DTYPE_FIFO	4	/* fifo (named pipe) */
 #define	DTYPE_KQUEUE	5	/* event queue */
@@ -66,6 +66,7 @@ struct vnode;
 #define	DTYPE_DEV	11	/* Device specific fd type */
 #define	DTYPE_PROCDESC	12	/* process descriptor */
 #define	DTYPE_LINUXEFD	13	/* emulation eventfd type */
+#define	DTYPE_SOLISTEN	14	/* listen(2)ing socket */
 
 #ifdef _KERNEL
 
@@ -224,6 +225,7 @@ struct xfile {
 extern struct fileops vnops;
 extern struct fileops badfileops;
 extern struct fileops socketops;
+extern struct fileops solistenops;
 extern int maxfiles;		/* kernel limit on number of open files */
 extern int maxfilesperproc;	/* per process limit on number of open files */
 extern volatile int openfiles;	/* actual number of open files */
Index: sys/sys/protosw.h
===================================================================
--- sys/sys/protosw.h	(revision 312784)
+++ sys/sys/protosw.h	(working copy)
@@ -39,6 +39,7 @@ struct mbuf;
 struct thread;
 struct sockaddr;
 struct socket;
+struct solisten;
 struct sockopt;
 
 /*#ifdef _KERNEL*/
@@ -68,7 +69,7 @@ struct sockopt;
 typedef int	pr_input_t (struct mbuf **, int*, int);
 typedef int	pr_output_t (struct mbuf *, struct socket *, ...);
 typedef void	pr_ctlinput_t (int, struct sockaddr *, void *);
-typedef int	pr_ctloutput_t (struct socket *, struct sockopt *);
+typedef int	pr_ctloutput_t (void *, struct sockopt *);
 typedef	void	pr_init_t (void);
 typedef	void	pr_fasttimo_t (void);
 typedef	void	pr_slowtimo_t (void);
@@ -196,8 +197,8 @@ struct pr_usrreqs {
 		    struct ifnet *ifp, struct thread *td);
 	void	(*pru_detach)(struct socket *so);
 	int	(*pru_disconnect)(struct socket *so);
-	int	(*pru_listen)(struct socket *so, int backlog,
-		    struct thread *td);
+	int	(*pru_listen)(struct socket *so, struct solisten *sol,
+		    int backlog, struct thread *td);
 	int	(*pru_peeraddr)(struct socket *so, struct sockaddr **nam);
 	int	(*pru_rcvd)(struct socket *so, int flags);
 	int	(*pru_rcvoob)(struct socket *so, struct mbuf *m, int flags);
@@ -223,6 +224,7 @@ struct pr_usrreqs {
 		    struct ucred *cred, struct thread *td);
 	void	(*pru_sosetlabel)(struct socket *so);
 	void	(*pru_close)(struct socket *so);
+	void	(*pru_listenclose)(struct solisten *sol);
 	int	(*pru_bindat)(int fd, struct socket *so, struct sockaddr *nam,
 		    struct thread *td);
 	int	(*pru_connectat)(int fd, struct socket *so,
@@ -248,7 +250,8 @@ int	pru_connect2_notsupp(struct socket *so1, struc
 int	pru_control_notsupp(struct socket *so, u_long cmd, caddr_t data,
 	    struct ifnet *ifp, struct thread *td);
 int	pru_disconnect_notsupp(struct socket *so);
-int	pru_listen_notsupp(struct socket *so, int backlog, struct thread *td);
+int	pru_listen_notsupp(struct socket *so, struct solisten *sol,
+	    int backlog, struct thread *td);
 int	pru_peeraddr_notsupp(struct socket *so, struct sockaddr **nam);
 int	pru_rcvd_notsupp(struct socket *so, int flags);
 int	pru_rcvoob_notsupp(struct socket *so, struct mbuf *m, int flags);
Index: sys/sys/socket.h
===================================================================
--- sys/sys/socket.h	(revision 312784)
+++ sys/sys/socket.h	(working copy)
@@ -117,7 +117,9 @@ typedef	__uintptr_t	uintptr_t;
  * Option flags per-socket.
  */
 #define	SO_DEBUG	0x0001		/* turn on debugging info recording */
+#if 0
 #define	SO_ACCEPTCONN	0x0002		/* socket has had listen() */
+#endif
 #define	SO_REUSEADDR	0x0004		/* allow local address reuse */
 #define	SO_KEEPALIVE	0x0008		/* keep connections alive */
 #define	SO_DONTROUTE	0x0010		/* just use interface addresses */
@@ -704,9 +706,5 @@ void so_sowwakeup(struct socket *so);
 void so_lock(struct socket *so);
 void so_unlock(struct socket *so);
 
-void so_listeners_apply_all(struct socket *so, void (*func)(struct socket *, void *), void *arg);
-
-#endif
-
-
+#endif /* _KERNEL */
 #endif /* !_SYS_SOCKET_H_ */
Index: sys/sys/socketvar.h
===================================================================
--- sys/sys/socketvar.h	(revision 312784)
+++ sys/sys/socketvar.h	(working copy)
@@ -58,6 +58,7 @@ struct vnet;
 typedef	u_quad_t so_gen_t;
 
 struct socket;
+struct solisten;
 
 /*-
  * Locking key to struct socket:
@@ -64,7 +65,7 @@ struct socket;
  * (a) constant after allocation, no locking required.
  * (b) locked by SOCK_LOCK(so).
  * (c) locked by SOCKBUF_LOCK(&so->so_rcv).
- * (e) locked by ACCEPT_LOCK().
+ * (e) locked by SOLISTEN_LOCK() of corresponding listening socket.
  * (f) not locked since integer reads/writes are atomic.
  * (g) used only as a sleep/wakeup address, no value.
  * (h) locked by global mutex so_global_mtx.
@@ -79,25 +80,8 @@ struct socket {
 	void	*so_pcb;		/* protocol control block */
 	struct	vnet *so_vnet;		/* (a) network stack instance */
 	struct	protosw *so_proto;	/* (a) protocol handle */
-/*
- * Variables for connection queuing.
- * Socket where accepts occur is so_head in all subsidiary sockets.
- * If so_head is 0, socket is not related to an accept.
- * For head socket so_incomp queues partially completed connections,
- * while so_comp is a queue of connections ready to be accepted.
- * If a connection is aborted and it has so_head set, then
- * it has to be pulled out of either so_incomp or so_comp.
- * We allow connections to queue up based on current queue lengths
- * and limit on number of queued connections for this socket.
- */
-	struct	socket *so_head;	/* (e) back pointer to listen socket */
-	TAILQ_HEAD(, socket) so_incomp;	/* (e) queue of partial unaccepted connections */
-	TAILQ_HEAD(, socket) so_comp;	/* (e) queue of complete unaccepted connections */
+	struct	solisten *so_listen;	/* (e) back pointer to listen socket */
 	TAILQ_ENTRY(socket) so_list;	/* (e) list of unaccepted connections */
-	u_int	so_qlen;		/* (e) number of unaccepted connections */
-	u_int	so_incqlen;		/* (e) number of unaccepted incomplete
-					   connections */
-	u_int	so_qlimit;		/* (e) max number queued connections */
 	short	so_timeo;		/* (g) connection timeout */
 	u_short	so_error;		/* (f) error affecting connection */
 	struct	sigio *so_sigio;	/* [sg] information for async I/O or
@@ -112,11 +96,6 @@ struct socket {
 	/* NB: generation count must not be first. */
 	so_gen_t so_gencnt;		/* (h) generation count */
 	void	*so_emuldata;		/* (b) private data for emulators */
- 	struct so_accf {
-		struct	accept_filter *so_accept_filter;
-		void	*so_accept_filter_arg;	/* saved filter args */
-		char	*so_accept_filter_str;	/* saved user args */
-	} *so_accf;
 	struct	osd	osd;		/* Object Specific extensions */
 	/*
 	 * so_fibnum, so_user_cookie and friends can be used to attach
@@ -135,17 +114,64 @@ struct socket {
 };
 
 /*
- * Global accept mutex to serialize access to accept queues and
- * fields associated with multiple sockets.  This allows us to
- * avoid defining a lock order between listen and accept sockets
- * until such time as it proves to be a good idea.
+ * Structure for listening socket.
+ * Socket where accepts occur is so_listen in all subsidiary sockets.
+ * If so_listen is NULL, socket is not related to an accept.
+ * For head socket so_incomp queues partially completed connections,
+ * while so_comp is a queue of connections ready to be accepted.
+ * If a connection is aborted and it has so_listen set, then
+ * it has to be pulled out of either so_incomp or so_comp.
+ * We allow connections to queue up based on current queue lengths
+ * and limit on number of queued connections for this socket.
  */
-extern struct mtx accept_mtx;
-#define	ACCEPT_LOCK_ASSERT()		mtx_assert(&accept_mtx, MA_OWNED)
-#define	ACCEPT_UNLOCK_ASSERT()		mtx_assert(&accept_mtx, MA_NOTOWNED)
-#define	ACCEPT_LOCK()			mtx_lock(&accept_mtx)
-#define	ACCEPT_UNLOCK()			mtx_unlock(&accept_mtx)
+TAILQ_HEAD(accept_queue, socket);
+struct solisten {
+	/*
+	 * Data inherited from 'struct socket' before listen(2)
+	 * mutation, to be copied to our children sockets.
+	 */
+	short		sol_type;
+	short		sol_options;
+	short		sol_linger;
+	short		sol_state;
+	int		sol_fibnum;
+	int		sol_sbrcv_lowat;
+	int		sol_sbsnd_lowat;
+	u_int		sol_sbrcv_hiwat;
+	u_int		sol_sbsnd_hiwat;
+	short		sol_sbrcv_flags;
+	short		sol_sbsnd_flags;
+	sbintime_t	sol_sbrcv_timeo;
+	sbintime_t	sol_sbsnd_timeo;
+	struct protosw	*sol_proto;
+	struct vnet	*sol_vnet;
+	struct ucred	*sol_cred;
+	struct label	*sol_label;
+	struct sigio	*sol_sigio;
+	void		*sol_pcb;
 
+	/* accept_filter(9) optional data */
+	struct	accept_filter	*sol_accept_filter;
+	void			*sol_accept_filter_arg;	/* saved filter args */
+	char			*sol_accept_filter_str;	/* saved user args */
+
+	/* Actual queue management. */
+	struct mtx	sol_mutex;
+	struct selinfo	sol_selinfo;
+	u_int		sol_qlen;    /* (e) number of unaccepted connections */
+	u_int		sol_incqlen; /* (e) number of unaccepted incomplete
+				       connections */
+	u_int		sol_qlimit;  /* (e) max number queued connections */
+	u_int		sol_error;
+	/* (e) queue of partial unaccepted connections */
+	struct accept_queue	sol_incomp;
+	/* (e) queue of complete unaccepted connections */
+	struct accept_queue	sol_comp;
+};
+
+#define	SOLISTEN_LOCK(sol)	mtx_lock(&(sol)->sol_mutex)
+#define	SOLISTEN_UNLOCK(sol)	mtx_unlock(&(sol)->sol_mutex)
+
 /*
  * Per-socket mutex: we reuse the receive socket buffer mutex for space
  * efficiency.  This decision should probably be revisited as we optimize
@@ -212,8 +238,7 @@ struct xsocket {
 
 /* can we read something from so? */
 #define	soreadabledata(so) \
-    (sbavail(&(so)->so_rcv) >= (so)->so_rcv.sb_lowat || \
-	!TAILQ_EMPTY(&(so)->so_comp) || (so)->so_error)
+	(sbavail(&(so)->so_rcv) >= (so)->so_rcv.sb_lowat ||  (so)->so_error)
 #define	soreadable(so) \
 	(soreadabledata(so) || ((so)->so_rcv.sb_state & SBS_CANTRCVMORE))
 
@@ -236,16 +261,13 @@ struct xsocket {
 } while (0)
 
 #define	sorele(so) do {							\
-	ACCEPT_LOCK_ASSERT();						\
 	SOCK_LOCK_ASSERT(so);						\
 	if ((so)->so_count <= 0)					\
 		panic("sorele");					\
 	if (--(so)->so_count == 0)					\
 		sofree(so);						\
-	else {								\
+	else								\
 		SOCK_UNLOCK(so);					\
-		ACCEPT_UNLOCK();					\
-	}								\
 } while (0)
 
 /*
@@ -285,11 +307,11 @@ struct xsocket {
 struct accept_filter {
 	char	accf_name[16];
 	int	(*accf_callback)
-		(struct socket *so, void *arg, int waitflag);
+		(struct socket *, void *, int);
 	void *	(*accf_create)
-		(struct socket *so, char *arg);
+		(struct solisten *, char *);
 	void	(*accf_destroy)
-		(struct socket *so);
+		(struct solisten *);
 	SLIST_ENTRY(accept_filter) accf_next;
 };
 
@@ -296,6 +318,7 @@ struct accept_filter {
 #ifdef MALLOC_DECLARE
 MALLOC_DECLARE(M_ACCF);
 MALLOC_DECLARE(M_PCB);
+MALLOC_DECLARE(M_SOLISTEN);
 MALLOC_DECLARE(M_SONAME);
 #endif
 
@@ -344,7 +367,8 @@ struct uio;
  */
 int	getsockaddr(struct sockaddr **namp, caddr_t uaddr, size_t len);
 int	getsock_cap(struct thread *td, int fd, cap_rights_t *rightsp,
-	    struct file **fpp, u_int *fflagp, struct filecaps *havecaps);
+	    struct file **fpp, u_int *fflagp, struct filecaps *havecaps,
+	    short type);
 void	soabort(struct socket *so);
 int	soaccept(struct socket *so, struct sockaddr **nam);
 void	soaio_enqueue(struct task *task);
@@ -365,13 +389,8 @@ int	sodisconnect(struct socket *so);
 struct	sockaddr *sodupsockaddr(const struct sockaddr *sa, int mflags);
 void	sofree(struct socket *so);
 void	sohasoutofband(struct socket *so);
-int	solisten(struct socket *so, int backlog, struct thread *td);
-void	solisten_proto(struct socket *so, int backlog);
-int	solisten_proto_check(struct socket *so);
-struct socket *
-	sonewconn(struct socket *head, int connstatus);
-
-
+struct socket * sonewconn(struct solisten *, int);
+struct socket * sopeeloff(struct socket *);
 int	sopoll(struct socket *so, int events, struct ucred *active_cred,
 	    struct thread *td);
 int	sopoll_generic(struct socket *so, int events,
@@ -409,6 +428,17 @@ int	selsocket(struct socket *so, int events, struc
 	    struct thread *td);
 
 /*
+ * Listening sockets.
+ */
+int	solisten(struct socket *so, int backlog, struct thread *td,
+	    struct file *fp);
+int	sollisten(struct solisten *so, int backlog, struct thread *td,
+	    struct file *fp);
+int	solistenpoll(struct solisten *, int, struct ucred *a, struct thread *);
+int	solistenclose(struct solisten *);
+void	soltoxsocket(struct solisten *so, struct xsocket *xso);
+
+/*
  * Accept filter functions (duh).
  */
 int	accept_filt_add(struct accept_filter *filt);
Index: sys/sys/sockopt.h
===================================================================
--- sys/sys/sockopt.h	(revision 312784)
+++ sys/sys/sockopt.h	(working copy)
@@ -40,6 +40,7 @@
 
 struct thread;
 struct socket;
+struct solisten;
 
 /*
  * Argument structure for sosetopt et seq.  This is in the KERNEL
@@ -58,6 +59,8 @@ struct	sockopt {
 
 int	sosetopt(struct socket *so, struct sockopt *sopt);
 int	sogetopt(struct socket *so, struct sockopt *sopt);
+int	solsetopt(struct solisten *so, struct sockopt *sopt);
+int	solgetopt(struct solisten *so, struct sockopt *sopt);
 int	sooptcopyin(struct sockopt *sopt, void *buf, size_t len, size_t minlen);
 int	sooptcopyout(struct sockopt *sopt, const void *buf, size_t len);
 /* XXX; prepare mbuf for (__FreeBSD__ < 3) routines. */
@@ -64,8 +67,8 @@ int	sooptcopyout(struct sockopt *sopt, const void
 int	soopt_getm(struct sockopt *sopt, struct mbuf **mp);
 int	soopt_mcopyin(struct sockopt *sopt, struct mbuf *m);
 int	soopt_mcopyout(struct sockopt *sopt, struct mbuf *m);
-int	do_getopt_accept_filter(struct socket *so, struct sockopt *sopt);
-int	do_setopt_accept_filter(struct socket *so, struct sockopt *sopt);
+int	accept_filt_getopt(struct solisten *, struct sockopt *);
+int	accept_filt_setopt(struct solisten *, struct sockopt *);
 int	so_setsockopt(struct socket *so, int level, int optname,
 	    void *optval, size_t optlen);
 
Index: sys/sys/unpcb.h
===================================================================
--- sys/sys/unpcb.h	(revision 312784)
+++ sys/sys/unpcb.h	(working copy)
@@ -66,7 +66,10 @@ LIST_HEAD(unp_head, unpcb);
 
 struct unpcb {
 	LIST_ENTRY(unpcb) unp_link; 	/* glue on list of all PCBs */
-	struct	socket *unp_socket;	/* pointer back to socket */
+	union {
+		struct	socket *unp_socket;	/* pointer back to socket */
+		struct	solisten *unp_listen;	/* to listening socket */
+	};
 	struct	file *unp_file;		/* back-pointer to file for gc. */
 	struct	vnode *unp_vnode;	/* if associated with file */
 	ino_t	unp_ino;		/* fake inode number */
@@ -93,13 +96,14 @@ struct unpcb {
  * to determine whether the contents should be sent to the user or
  * not.
  *
- * UNP_HAVEPCCACHED - indicates that the unp_peercred member is filled
- * in, but does *not* contain the credentials of the connected peer
+ * UNP_LISTENING - indicates that unp is listening, and unp_listen should
+ * be dereferenced instead of unp_socket. The unp_peercred member is
+ * filled in, but does *not* contain the credentials of the connected peer
  * (there may not even be a peer).  This is set in unp_listen() when
  * it fills in unp_peercred for later consumption by unp_connect().
  */
 #define UNP_HAVEPC			0x001
-#define UNP_HAVEPCCACHED		0x002
+#define UNP_LISTENING			0x002
 #define	UNP_WANTCRED			0x004	/* credentials wanted */
 #define	UNP_CONNWAIT			0x008	/* connect blocks until accepted */
 
@@ -121,6 +125,7 @@ struct unpcb {
 #define	UNPGC_IGNORE_RIGHTS		0x8	/* Attached rights are freed */
 
 #define	sotounpcb(so)	((struct unpcb *)((so)->so_pcb))
+#define	soltounpcb(sol)	((struct unpcb *)((sol)->sol_pcb))
 
 /* Hack alert -- this structure depends on <sys/socketvar.h>. */
 #ifdef	_SYS_SOCKETVAR_H_
Index: sys/sys/vnode.h
===================================================================
--- sys/sys/vnode.h	(revision 312784)
+++ sys/sys/vnode.h	(working copy)
@@ -112,14 +112,13 @@ struct vnode {
 
 	/*
 	 * Type specific fields, only one applies to any given vnode.
-	 * See #defines below for renaming to v_* namespace.
 	 */
 	union {
-		struct mount	*vu_mount;	/* v ptr to mountpoint (VDIR) */
-		struct socket	*vu_socket;	/* v unix domain net (VSOCK) */
-		struct cdev	*vu_cdev; 	/* v device (VCHR, VBLK) */
-		struct fifoinfo	*vu_fifoinfo;	/* v fifo (VFIFO) */
-	} v_un;
+		struct mount	*v_mountedhere;	/* v ptr to mountpoint (VDIR) */
+		struct unpcb	*v_unpcb;	/* v unix domain net (VSOCK) */
+		struct cdev	*v_rdev; 	/* v device (VCHR, VBLK) */
+		struct fifoinfo	*v_fifoinfo;	/* v fifo (VFIFO) */
+	};
 
 	/*
 	 * vfs_hash: (mount + inode) -> vnode hash.  The hash value
@@ -175,11 +174,6 @@ struct vnode {
 
 #endif /* defined(_KERNEL) || defined(_KVM_VNODE) */
 
-#define	v_mountedhere	v_un.vu_mount
-#define	v_socket	v_un.vu_socket
-#define	v_rdev		v_un.vu_cdev
-#define	v_fifoinfo	v_un.vu_fifoinfo
-
 #define	bo2vnode(bo)	__containerof((bo), struct vnode, v_bufobj)
 
 /* XXX: These are temporary to avoid a source sweep at this time */
@@ -200,7 +194,7 @@ struct xvnode {
 	long	xv_numoutput;			/* num of writes in progress */
 	enum	vtype xv_type;			/* vnode type */
 	union {
-		void	*xvu_socket;		/* socket, if VSOCK */
+		void	*xvu_socket;		/* unpcb, if VSOCK */
 		void	*xvu_fifo;		/* fifo, if VFIFO */
 		dev_t	xvu_rdev;		/* maj/min, if VBLK/VCHR */
 		struct {
